package hr.geometrics;

import java.io.Serializable;

public class Line implements Serializable {

	private static final long serialVersionUID = 635836784931063419L;
	
	private int x1;
	private int y1;
	private int x2;
	private int y2;
	
	private Direction direction = null;
	
	public Line(int x1, int y1, int x2, int y2) {
		
		this.x1 = x1;
		this.x2 = x2;
		this.y1 = y1;
		this.y2 = y2;
		
		this.direction = new Direction(this);
		
	}
	
	/**
	 * @return the x1
	 */
	public int getX1() {
		return x1;
	}
	
	
	/**
	 * @return the y1
	 */
	public int getY1() {
		return y1;
	}
	
	
	/**
	 * @return the x2
	 */
	public int getX2() {
		return x2;
	}
	
	
	/**
	 * @return the y2
	 */
	public int getY2() {
		return y2;
	}
	
	public Direction getDirection() {
		
		return this.direction;
		
	}
	
	public String toString() {
		
		return "Line from ("+this.x1+", "+this.y1+") to ("+this.x2+", "+this.y2+")";
		
	}
	
	public Point getStartPoint() {
		return new Point(x1, y1);
	}
	
	public Point getEndPoint() {
		return new Point(x2, y2);
	}
	
}
