package hr.geometrics;

import java.io.Serializable;

public class Point implements Serializable {

	private static final long serialVersionUID = 3736853179962957548L;
	
	private double x;
	private double y;
	
	public Point(int x, int y) {
		
		this.x = new Integer(x).doubleValue();
		this.y = new Integer(y).doubleValue();
		
	}
	
	public Point(double x, double y) {
		
		this.x = x;
		this.y = y;
		
	}

	/**
	 * @return the x
	 */
	public double getX() {
		return x;
	}

	/**
	 * @return the y
	 */
	public double getY() {
		
		return y;
		
	}
	
	public double distanceFrom(Point p) {
		
		return Math.sqrt( Math.pow(p.getX() - this.getX(), 2) + Math.pow(p.getY() - this.getY(), 2) );
		
	}
	
	public double distanceFrom(Direction direction) {
		
		double distance;
		
		distance = 
			Math.abs(direction.getA()*this.getX() + direction.getB()*this.getY() + direction.getC())
			/ Math.sqrt(Math.pow(direction.getA(), 2) + Math.pow(direction.getB(), 2));
		
		return distance;
		
	}
	
	public String toString() {
		
		return "Point ("+this.getX()+", "+this.getY()+")";
		
	}
	
	
}
