package hr.geometrics;

public class Vector {

	private double x;
	private double y;
	private double length;
	
	public Vector(double x, double y) {	
		
		this.x = x;
		this.y = y;
		this.length = Math.sqrt(Math.pow(x, 2) + Math.pow(y, 2));
		
	}
	
	public double getAngle() {
		
		return Math.atan2(this.getY(), this.getX());
		
	}

	/**
	 * @return the x
	 */
	public double getX() {
		return x;
	}

	/**
	 * @return the y
	 */
	public double getY() {
		return y;
	}
	
	@Override
	public String toString() {
		return "(" + this.getX() + ", " + this.getY() + ")";
	}
	
	public double scalarProduct(Vector v) {
		return this.getX()*v.getX() + this.getY()*v.getY();
	}
	
	/**
	 * Rotate vector for given agle 
	 * @param angle Angle in radians
	 * @return instance of vector (mutable)
	 */
	public Vector rotate(double angle) {
		
		double finalAngle = this.getAngle() + angle;
				
		this.x = this.length * Math.cos(finalAngle);
		this.y = this.length * Math.sin(finalAngle);/**/
		
		return this;
	}
	
}
