package hr.servlets;

import java.io.File;
import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.gson.Gson;

public class SimulationManager extends HttpServlet {

	private static final long serialVersionUID = -3081538221813499102L;

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		
		String path = req.getParameter("path");
		if (path == null) {
			listAllSimulations(req, resp);
		} else {
			Scanner sc = new Scanner(new File(path));
			StringBuilder sb = new StringBuilder();
			while (sc.hasNextLine()) {
				sb.append(sc.nextLine()).append("\n");
			}
			sc.close();
			resp.getWriter().print(sb.toString());
		}
		
	}

	private void listAllSimulations(HttpServletRequest req,
			HttpServletResponse resp) throws IOException {

		List<String> simulations = new LinkedList<>();
		
		File simulationDir = new File("/Users/mario/workspace/Seminar/runs/");
		for (File currFile : simulationDir.listFiles()) {
			if (currFile.isDirectory()) {
				for (File currSimulation : currFile.listFiles()) {
					if (currSimulation.isFile()) {
						String[] parts = currSimulation.getPath().toString().split("\\.");
						String ext = parts[parts.length-1];
						if (ext.equals("txt")) {
							simulations.add(currSimulation.getAbsolutePath().toString());
						}
					}
				}
			}
		}
				
		Gson gson = new Gson();
		
	    Collections.reverse(simulations);
		
		resp.getWriter().print(gson.toJson(simulations));
		
	}
	
	
	
}
